#!/usr/bin/python
# coding: utf-8

import sys,os,json


os.chdir("/www/server/panel")


sys.path.append("class/")
import public


class ftp_port_main:
    __plugin_path = "/www/server/panel/plugin/ftp_port/"
    __config = None

    def  __init__(self):
        #import ftplib
        #reload(ftplib)
        pass
    
    def get_status(self,args):
        if not os.path.isdir("/www/server/panel/plugin/ftp"): return -1
        if not os.path.isfile("/www/server/panel/ftplib.py"): return -101
        if not os.path.isfile("/www/server/panel/plugin/ftp/ftplib.py"): return -101
        return 0

    def init_plugin(self,args):
        if not os.path.isfile(self.__plugin_path + "install.sh"): return -101
        public.ExecShell("bash " + self.__plugin_path + "install.sh install")
        return 0

    def get_configs(self,args):
        return self.__get_config(None,True);

    def set_configs(self,args):
        if not 'data' in args: args.data = ""
        config_file = self.__plugin_path + 'config.json'
        public.WriteFile(config_file,args.data)
        return 0;
    
    def getPublicIp(self,args):
        return public.GetLocalIp()

    #读取配置项(插件自身的配置文件)
    #@param key 取指定配置项，若不传则取所有配置[可选]
    #@param force 强制从文件重新读取配置项[可选]
    def __get_config(self,key=None,force=False):
        #判断是否从文件读取配置
        if not self.__config or force:
            config_file = self.__plugin_path + 'config.json'
            if not os.path.exists(config_file): return None
            f_body = public.ReadFile(config_file)
            if not f_body: return None
            self.__config = json.loads(f_body)

        #取指定配置项
        if key:
            if key in self.__config: return self.__config[key]
            return None
        return self.__config

    #设置配置项(插件自身的配置文件)
    #@param key 要被修改或添加的配置项[可选]
    #@param value 配置值[可选]
    def __set_config(self,key=None,value=None):
        #是否需要初始化配置项
        if not self.__config: self.__config = {}

        #是否需要设置配置值
        if key:
            self.__config[key] = value

        #写入到配置文件
        config_file = self.__plugin_path + 'config.json'
        public.WriteFile(config_file,json.dumps(self.__config))
        return True

